# Class Vector4I.Builder

java.lang.Object
com.io7m.jtensors.core.unparameterized.vectors.Vector4I.Builder

Enclosing class:
  `Vector4I`

public static final class Vector4I.Builder extends Object
Builds instances of type `Vector4I`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Vector4I`
  `build()`
  Builds a new `Vector4I`.
  `final Vector4I.Builder`
  `from(Vector4IType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.Vector4IType` instance.
  `final Vector4I.Builder`
  `from(VectorReadable2IType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2IType` instance.
  `final Vector4I.Builder`
  `from(VectorReadable3IType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3IType` instance.
  `final Vector4I.Builder`
  `from(VectorReadable4IType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable4IType` instance.
  `final Vector4I.Builder`
  `setW(int w)`
  Initializes the value for the `w` attribute.
  `final Vector4I.Builder`
  `setX(int x)`
  Initializes the value for the `x` attribute.
  `final Vector4I.Builder`
  `setY(int y)`
  Initializes the value for the `y` attribute.
  `final Vector4I.Builder`
  `setZ(int z)`
  Initializes the value for the `z` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final Vector4I.Builder from(VectorReadable3IType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3IType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final Vector4I.Builder from(Vector4IType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.Vector4IType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final Vector4I.Builder from(VectorReadable2IType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2IType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final Vector4I.Builder from(VectorReadable4IType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable4IType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setX

    public final Vector4I.Builder setX(int x)
    Initializes the value for the `x` attribute.
    Parameters:
      `x` - The value for x
    Returns:
      `this` builder for use in a chained invocation

  - ### setY

    public final Vector4I.Builder setY(int y)
    Initializes the value for the `y` attribute.
    Parameters:
      `y` - The value for y
    Returns:
      `this` builder for use in a chained invocation

  - ### setZ

    public final Vector4I.Builder setZ(int z)
    Initializes the value for the `z` attribute.
    Parameters:
      `z` - The value for z
    Returns:
      `this` builder for use in a chained invocation

  - ### setW

    public final Vector4I.Builder setW(int w)
    Initializes the value for the `w` attribute.
    Parameters:
      `w` - The value for w
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public Vector4I build()
    Builds a new `Vector4I`.
    Returns:
      An immutable instance of Vector4I
    Throws:
      `IllegalStateException` - if any required attributes are missing